/*
   Figure 5.23 A Solution to the Readers/Writers Problem Using
                Semaphores: Writers Have Priority
*/
int readcount, writecount;
semaphore x = 1,
          y = 1,
          z = 1,
          wsem = 1,
          rsem = 1;

void reader()
{
   while (true)
   {
      semWait(z);      // make the readers queue up here (on z)
        semWait(rsem); // rather than here, on rsem
          semWait(x);
            readcount++;
            if (readcount == 1)
               semWait(wsem);
          semSignal(x);
        semSignal(rsem);
      semSignal(z);
      READUNIT();
      semWait(x);
        readcount--;
        if (readcount == 0)
           semSignal(wsem);
      semSignal(x);
   }
}

void writer()
{
   while (true)
   {
      semWait(y);
        writecount++;
        if (writecount == 1)
           semWait(rsem);
      semSignal(y);
      semWait(wsem);
        WRITEUNIT();
      semSignal(wsem);
      semWait(y);
        writecount--;
        if (writecount == 0)
           semSignal(rsem);
      semSignal(y);
   }
}

void main()
{
   readcount = writecount = 0;
   parbegin(reader, writer);
}