/*
   Figure 5.22 A Solution to the Readers/Writers Problem Using
               Semaphores: Readers Have Priority
*/
int readcount;
semaphore x = 1, wsem = 1;

void reader()
{
   while (true)
   {
      semWait (x);
      readcount++;
      if (readcount == 1)
         semWait (wsem);
      semSignal (x);
      READUNIT();
      semWait (x);
      readcount--;
      if (readcount == 0)
         semSignal (wsem);
      semSignal (x);
   }
}

void writer()
{
   while (true)
   {
      semWait (wsem);
      WRITEUNIT();
      semSignal (wsem);
   }
}

void main()
{
   readcount = 0;
   parbegin (reader, writer);
}